service system/modules {
	need = system/initial system/mountroot

	start {
		# Set the path
		export PATH=/bin:/sbin:/usr/bin:/usr/sbin

		# Read functions
		. /etc/rc.d/init.d/functions

		# And sysconfig
		if [ -f /etc/sysconfig/system ]; then
			. /etc/sysconfig/system
		fi

		# Should not fail if kernel do not have module
		# support compiled in ...
		if [ ! -f /proc/modules ]; then
			USEMODULES=
		elif ! grep -iq nomodules /proc/cmdline; then
			USEMODULES=y
		else
			USEMODULES=
		fi

		# Run depmod if RUN_DEPMOD != "no" and:
		# a) user requested or RUN_DEPMOD="";
		# b) modules.dep is missing
		# c) modules.dep is older than /etc/modules.conf or /lib/modules/`uname -r`
		if ! is_no "$RUN_DEPMOD" && [ -n "$USEMODULES" ]; then
				if is_yes "$RUN_DEPMOD" || [ -z "$RUN_DEPMOD" ]; then
				run_cmd "Finding module dependencies" depmod -a
			elif [ "$RUN_DEPMOD" = "ifmissing" ]; then
				run_cmd "Finding module dependencies" depmod -A
			fi
		fi

		if [ -f /proc/sys/kernel/modprobe ]; then
			if [ -n "$USEMODULES" ]; then
				sysctl -w kernel.modprobe="/sbin/modprobe" >/dev/null 2>&1
				sysctl -w kernel.hotplug="/sbin/hotplug" >/dev/null 2>&1
			else
				# We used to set this to NULL, but that causes
				# 'failed to exec' messages"
				sysctl -w kernel.modprobe="/bin/true" >/dev/null 2>&1
				sysctl -w kernel.hotplug="/bin/true" >/dev/null 2>&1
			fi
		fi

		# Load usb storage here, to match most other things
		if [ -n "$needusbstorage" ]; then
				modprobe -k usb-storage >/dev/null 2>&1
		fi

		# Load modules
		if [ -x /etc/rc.d/rc.modules ]; then
			/etc/rc.d/rc.modules
		fi

		exit 0
	}
}
